



/*
 *
 * Multithreaded HTTP Download Accelarator: Aget
 * (c) 2002, Murat Balaban <murat@enderunix.org>
 *
 * See COPYING for copyright and copying restrictions
 *
 */



#ifndef S_H
#define S_H

#include <pthread.h>
#include <netinet/in.h>

#define HEADREQSIZ	512
#define HEADRECVSIZ	2048

#define GETREQSIZ	2048
#define GETRECVSIZ	2048

#define HTTPPORT        80
#define FTPREQ  21
#define UNKNOWNREQ      2

#define MAXURLSIZ       1024
#define MAXHOSTSIZ      256
#define MAXFILESIZ      512
#define MAXIPSIZ	16

#define PROGVERSION	"EnderUNIX Aget v0.2"

#define HEADREQ	"HEAD %s HTTP/1.1\r\nHost: %s\r\nUser-Agent: %s\r\n\r\n"
#define GETREQ	"GET %s HTTP/1.1\r\nHost: %s\r\nUser-Agent: %s\r\nRange: bytes=%ld-\r\nConnection: close\r\n\r\n"

static pthread_mutex_t thread_exit_mtx = PTHREAD_MUTEX_INITIALIZER;
static pthread_cond_t thread_exit_cnd = PTHREAD_COND_INITIALIZER;
static int thread_exit_cnt = 0;

typedef struct request {
	char host[MAXHOSTSIZ];
	char url[MAXURLSIZ];
	char file[MAXFILESIZ];
	char ip[MAXIPSIZ];
	int port;
	int clength;
} request;

typedef struct thread_data {
	char host[MAXHOSTSIZ];
	char url[MAXURLSIZ];
	char ip[MAXIPSIZ];
	char file[MAXFILESIZ];
	int port;
	long soffset;
	long foffset;
	FILE *fp;
	int tind;
} thread_data;


void Log(char *);
void head_req(struct request *);
void *partialGetHandler(void *);


#endif
